// Definicija klase geometrijskih figura (Figura).

#ifndef _figura1_h_
#define _figura1_h_

#include "tacka2.h"

class Figura {
	Tacka T;                                  // Teziste figure.
public:
	Figura (const Tacka& tt=ORG): T(tt)  {}   // Konstruktor.
	virtual ~Figura () {}                     // Destruktor.
	virtual Figura* kopija () const =0;       // Stvaranje kopije.
	Figura& postavi (Real xx, Real yy)        // Postavljanje figure.
    { T = Tacka (xx, yy); return *this; }
	Figura& pomeri (Real dx, Real dy)         // Pomeranje figure.
    { T = Tacka ( T.aps() + dx, T.ord() + dy); return *this; }
	virtual Real O () const =0 ;              // Obim.
	virtual Real P () const =0 ;              // Povrsina.
protected:
	virtual void citaj (istream& dd)       { dd >> T; }          // Citanje.
	virtual void pisiVrstu (ostream& dd) const = 0; // mora se definisati u izv. klasi
	void pisiTeziste (ostream& dd) const { dd << "T=" << T; }  // ne moze se redefinisati izv. klasi
	virtual void pisiParametre (ostream& dd) const = 0; // mora se definisati u izv. klasi
	virtual void pisiEventualneSpecificnosti (ostream& dd) const {}; // moze se redefinisati izv. klasi
	friend istream& operator>> (istream& dd, Figura& ff) //Uopsteno citanje
	{ ff.citaj (dd); return dd; }                              //    i
	friend ostream& operator<< (ostream& dd, const Figura& ff)   // pisanje. Template Method DP.
	{ 
		dd.width(8); dd.setf(ios::left);
		ff.pisiVrstu(dd); // cista virtuelna metoda
		dd.unsetf(ios::left); 
		dd << '[';
		ff.pisiTeziste(dd); // obicna metoda, ne redefinise se
		dd << ", ";
		ff.pisiParametre(dd); // cista virtuelna metoda 
		dd << ']';
		ff.pisiEventualneSpecificnosti(dd); // 'hook' metoda, prazna je i moze se po potrebi redefinisati
		return dd; 
	}
} ;

#endif
